#include "Configuration.h"
#include <string>
#include <dirent.h>
#include <cstdio>
#include <iostream>
#include <fstream>
#include <algorithm>
#include <stdio.h>
#include <stdlib.h>

#ifdef WIN32
#include <windows.h>
#endif

Configuration::Configuration(){
	filename = "";
	serverIP = "000.000.000.000";

#ifndef PLATFORM_PANDORA
#ifdef WIN32
	//try and get it in my documents:
	char path[256];
	GetEnvironmentVariable("USERPROFILE",path,sizeof(path));
	filename.append(path);
	filename.append("/");
	printf("WIN32!!! filename: %s\n", filename.c_str());
#else
	// get in linux's good old home directory:
	fullscreen = 1;
	char * val;
	val = getenv( "HOME" );

	if (val != NULL) {
		printf("home: %s\n", val);
		filename = val;
		filename.append("/");
	}
#endif
#endif

	filename.append(".LSDLSave");
}

vector<string> split(const string& strValue, char separator)
{
    vector<string> vecstrResult;
    int startpos=0;
    int endpos=0;

    endpos = strValue.find_first_of(separator, startpos);
    while (endpos != -1)
    {
        vecstrResult.push_back(strValue.substr(startpos, endpos-startpos)); // add to vector
        startpos = endpos+1; //jump past sep
        endpos = strValue.find_first_of(separator, startpos); // find next
        if(endpos==-1)
        {
            //last one, so no 2nd param required to go to end of string
            vecstrResult.push_back(strValue.substr(startpos));
        }
    }

    return vecstrResult;
}

void Configuration::SetLevelComplete(int levelNum){
	bool inThere = GetLevelComplete(levelNum);
	// first, see if it's already in there:

	if(!inThere){
		//add it to the array
		printf("Completed level %d\n", levelNum);
		levelsCompleted.push_back(levelNum);
		printf("Total levels done so far %d\n", levelsCompleted.size());
	}
}

bool Configuration::GetLevelComplete(int levelNum){
	bool there = false;
	for(unsigned int n = 0; n < levelsCompleted.size(); n++){
		if(levelsCompleted.at(n) == levelNum){
			there = true;
		}
	}
	return there;
}

void Configuration::SetServerIP(string newValue){
	serverIP = newValue;
}

string Configuration::GetServerIP(){
	vector<string> quads = split(serverIP, '.');
	serverIP = "";
	string temp;

	temp = quads.at(0);
	if(temp.size() == 1){
		serverIP.append("00");
	}else if(temp.size() == 2){
		serverIP.append("0");
	}
	serverIP.append(temp);

	serverIP.append(".");
	temp = quads.at(1);
	if(temp.size() == 1){
		serverIP.append("00");
	}else if(temp.size() == 2){
		serverIP.append("0");
	}
	serverIP.append(temp);

	serverIP.append(".");
	temp = quads.at(2);
	if(temp.size() == 1){
		serverIP.append("00");
	}else if(temp.size() == 2){
		serverIP.append("0");
	}
	serverIP.append(temp);

	serverIP.append(".");
	temp = quads.at(3);
	if(temp.size() == 1){
		serverIP.append("00");
	}else if(temp.size() == 2){
		serverIP.append("0");
	}
	serverIP.append(temp);

	return serverIP;
}

bool Configuration::Save(){
	//write leveltitle to a file
	fstream file;

	printf("Saving: Filepath: %s\n", filename.c_str());

	file.open(filename.c_str(),ios::out);

	printf("levels done %d\n", levelsCompleted.size());
	for(unsigned int n = 0; n < levelsCompleted.size(); n++){
		file << levelsCompleted.at(n);
		file << "\n";
	}
	file << "--\n";

	//lame-ass method that depends on there always being data..

	//now save other stuff
	file << serverIP << "\n";
	file << fullscreen << "\n";

	file.close();

	return true;
}

bool Configuration::Load(){
	char str[200];
	FILE *fp;

	printf("opening config file: %s\n", filename.c_str());
	fp = fopen(filename.c_str(), "r");
	if(!fp) return 1; // bail out if file not found
	bool end = false;
	bool readingLevels = true;
	while(!end && fgets(str,sizeof(str),fp) != NULL)
	{
	   string line;
	   line = str;
	   line.erase(line.find_last_not_of(" \n\r\t")+1);

	   if(line.compare("--") == 0)
	   {
		   end = true;
		   readingLevels = false;
	   }
	   else if(readingLevels){
		   levelsCompleted.push_back(atoi(line.c_str()));
	   }
	}

	if(fgets(str,sizeof(str),fp) != NULL){
	   serverIP = str;
	   serverIP.erase(serverIP.find_last_not_of(" \n\r\t")+1);
	}

	if(fgets(str,sizeof(str),fp) != NULL){
		fullscreen = 0;//str;
	}


	return true;
}



