#include "LevelLoader.h"
//#include <vector>
#include <string>
#include <dirent.h>
#include <cstdio>
#include <iostream>
#include <fstream>
#include <algorithm>

LevelLoader::LevelLoader()
{
	currentSinglePlayerLevel=0;
	currentTwoPlayerLevel=0;
	levelSet=Fun;
	max_songs=30;
	songs.push_back(string("data/music/standard_ingame/cancan.mod"));
	songs.push_back(string("data/music/standard_ingame/lemming1.mod"));
	songs.push_back(string("data/music/standard_ingame/tim2.mod"));
	songs.push_back(string("data/music/standard_ingame/lemming2.mod"));
	songs.push_back(string("data/music/standard_ingame/tim8.mod"));
	songs.push_back(string("data/music/standard_ingame/tim3.mod"));
	songs.push_back(string("data/music/standard_ingame/tim5.mod"));
	songs.push_back(string("data/music/standard_ingame/doggie.mod"));
	songs.push_back(string("data/music/standard_ingame/tim6.mod"));
	songs.push_back(string("data/music/standard_ingame/lemming3.mod"));
	songs.push_back(string("data/music/standard_ingame/tim7.mod"));
	songs.push_back(string("data/music/standard_ingame/tim9.mod"));
	songs.push_back(string("data/music/standard_ingame/tim2.mod"));
	songs.push_back(string("data/music/standard_ingame/tim10.mod"));
	songs.push_back(string("data/music/standard_ingame/tim4.mod"));//level 15]
	songs.push_back(string("data/music/standard_ingame/tenlemmings.mod"));//level 16
	songs.push_back(string("data/music/standard_ingame/mountain.mod"));

	songs.push_back(string("data/music/standard_ingame/cancan.mod"));
	songs.push_back(string("data/music/standard_ingame/lemming1.mod"));
	songs.push_back(string("data/music/standard_ingame/tim2.mod"));
	songs.push_back(string("data/music/standard_ingame/lemming2.mod"));
	songs.push_back(string("data/music/standard_ingame/beasti.mod"));
	//songs.push_back(string("music/standard_ingame/LemEngine_Beast.mp3"));
	songs.push_back(string("data/music/standard_ingame/track_18.mod"));
	songs.push_back(string("data/music/standard_ingame/tim3.mod"));
	songs.push_back(string("data/music/standard_ingame/tim5.mod"));
	songs.push_back(string("data/music/standard_ingame/doggie.mod"));
	songs.push_back(string("data/music/standard_ingame/tim6.mod"));
	songs.push_back(string("data/music/standard_ingame/lemming3.mod"));
	songs.push_back(string("data/music/standard_ingame/tim7.mod"));
	songs.push_back(string("data/music/standard_ingame/tim9.mod"));
	songs.push_back(string("data/music/standard_ingame/tim1.mod"));

	onmlsongs.push_back(string("data/music/onml/tune1.mod"));
	onmlsongs.push_back(string("data/music/onml/tune2.mod"));
	onmlsongs.push_back(string("data/music/onml/tune3.mod"));
	onmlsongs.push_back(string("data/music/onml/tune4.mod"));
	onmlsongs.push_back(string("data/music/onml/tune5.mod"));
	onmlsongs.push_back(string("data/music/onml/tune6.mod"));

	holidaysongs.push_back(string("data/music/holiday/rudi.mod"));
	holidaysongs.push_back(string("data/music/holiday/jb.mod"));
	holidaysongs.push_back(string("data/music/holiday/kw.mod"));

	setupDone = false;
}

LevelLoader::~LevelLoader()
{

}

bool LevelLoader::SuperLemming(){
	return CurrentLevelCode() == 181;
}

string LevelLoader::GetSong()
{
	vector<string>* list;
	string song;
	if((int)levelSet < 4){
		list = &songs;
	}else if((int)levelSet < 8){
		list = &onmlsongs;
	}else{
		list = &holidaysongs;
	}

	if(currentSinglePlayerLevel>=0)
	{
		song = list->at(currentSinglePlayerLevel % (list->size()-1));
	}
	else
	{

		song =  list->at((list->size()-1) + currentSinglePlayerLevel);
	}
	printf("(LevelLoader) getting song %s\n", song.c_str());

	return song;
}

string* LevelLoader::GetTwoPlayerLevel(int n)
{
	return &twoPlayerLevels.at(currentTwoPlayerLevel);
}

string* LevelLoader::GetLevel()
{
	printf("(LevelLoader) getting level at %d\n", currentSinglePlayerLevel);
	int maxlevel = 255;
	int n = currentSinglePlayerLevel;

	if(n >= 0 && n < maxlevel )
	{
		n = n;//?!
	}
	else if(n < 0)
	{
		n = maxlevel - ((n*-1));
	}
	else if(n >= maxlevel )
	{
		n = n % maxlevel ;
	}
	int levelPos = levelPositions.at((int)levelSet);
	return &levels.at(levelPos+n);
}

std::string LevelLoader::GetLevelSetName(){
	return levelSetNames.at((int)levelSet);
}

void LevelLoader::Setup()
{
	if(!setupDone){
		count = 0;
		levelPositions.push_back(0);
		LoadSet("data/levels/1player/standard/Lems A - Fun/", "Fun");
		LoadSet("data/levels/1player/standard/Lems B - Tricky/", "Tricky");
		LoadSet("data/levels/1player/standard/Lems C - Taxing/", "Taxing");
		LoadSet("data/levels/1player/standard/Lems D - Mayhem/", "Mayhem");

		LoadSet("data/levels/1player/standard/Oh No A - Tame/", "Tame");
		LoadSet("data/levels/1player/standard/Oh No B - Crazy/", "Crazy");
		LoadSet("data/levels/1player/standard/Oh No C - Wild/", "Wild");
		LoadSet("data/levels/1player/standard/Oh No D - Wicked/", "Wicked");
		LoadSet("data/levels/1player/standard/Oh No E - Havoc/", "Havoc");

		LoadSet("data/levels/1player/standard/Xmas 1991/", "Xmas 91");
		LoadSet("data/levels/1player/standard/Xmas 1992/", "Xmas 92");
		LoadSet("data/levels/1player/standard/Xmas A - Frost/", "Frost");
		LoadSet("data/levels/1player/standard/Xmas B - Hail/", "Hail");
		LoadSet("data/levels/1player/standard/Xmas C - Flurry/", "Flurry");
		LoadSet("data/levels/1player/standard/Xmas D - Blizzard/", "Blizzard");

		LoadTwoPlayerLevels("data/levels/2player/");
		sort(twoPlayerLevels.begin(), twoPlayerLevels.end());

		//wrong exits
		//level 0 fine
		//level 1 swapped (flags okay)
		//level 2 fine
		//level 3 flags okay, entrance wrong
		//level 4 fine
		//level 5 fine
		//level 6 fine
		//level 7 flags swapped, start direction wrong
		//level 8 swapped
		//level 9  swapped, start direction wrong
		//level 10 swapped
		//level 11 swapped
		//level 12 swapped (FLAGS DEFINATLY)
		//level 13 FLAGS AND EXITS NEED SWapping
		//LEVEL 14 fine
		//level 15 okay
		//level 16 okay
		//level 17 entrances swapped. exits swapped
		//level 18 entrances swapped, exits swapped
		//level 19 fine!

		//twoPlayerHack[0].


		SetHack(0,  false, false, false, 0, 0);
		SetHack(1,  false, false, false, 0, 0);
		SetHack(2,  false, false, false, 0, 0);
		SetHack(3,  false, false, false, 0, 0);
		SetHack(4,  false, false, false, 0, 0);
		SetHack(5,  false, false, false, 0, 0);
		SetHack(6,  false, false, false, 0, 0);
		SetHack(7,  false, true, false, 1, 1);
		SetHack(8,  false, false, false, 0, 0);
		SetHack(9,  false, true, false, 1, 1);
		SetHack(10, false, true, false, 0, 0);
		SetHack(11, false, true, false, 0, 0);
		SetHack(12, false, true, false, 0, 0);
		SetHack(13, false, true, false, 0, 0);
		SetHack(14, false, false, false, 0, 0);
		SetHack(15, false, false, false, 0, 0);
		SetHack(16, false, false, false, 0, 0);
		SetHack(17, false, true, false, 0, 0);
		SetHack(18, false, true, true, 0, 0);
		SetHack(19, false, false, true, 0, 0);

		setupDone = true;
	}
}

int LevelLoader::CurrentLevelCode(){
	int levelPos = levelPositions.at((int)levelSet);
	return levelPos+currentSinglePlayerLevel;
}

/*
 *  bool entrances_swapped;
	bool flags_swapped;
	bool exits_swapped;
	int green_heading_right;
	int blue_heading_right;
 */
void LevelLoader::SetHack(int n, bool entrances,bool flags,bool exits, int green_right, int blue_right){
	twoPlayerHack[n].entrances_swapped = entrances;
	twoPlayerHack[n].flags_swapped = flags;
	twoPlayerHack[n].exits_swapped = exits;
	twoPlayerHack[n].blue_heading_right = blue_right;
	twoPlayerHack[n].green_heading_right = green_right;
}

LevelLoader::TwoPlayerLevelHack* LevelLoader::Get2PlayerLevelHack(){
	if(currentSinglePlayerLevel <= 19)
	{
		return &twoPlayerHack[currentSinglePlayerLevel];
	}else{
		return &twoPlayerHack[0];
	}
}

/*
void LevelLoader::SaveLevelComplete(){
	printf("sving vhit\n");
	//write leveltitle to a file
	fstream file;

	char * val;
	val = getenv( "HOME" );
	std::string retval = "";
	if (val != NULL) {
		printf("home: %s\n", val);
		retval = val;
	}

	retval.append("/.LSDLSave");

	printf("filepath: %s\n", retval.c_str());

	file.open(retval.c_str(),ios::out);
	file<<"Test Write to file";
	file<<GetLevel();
	file.close();
}*/

void LevelLoader::LoadSet(const char *path, const char *name)
{
	string str = string(path);
	//first off, we need to create a pointer to a directory
	vector<string> temp;

    DIR *pdir = NULL; // remember, it's good practice to initialise a pointer to NULL!
    pdir = opendir (path); // "." will refer to the current directory

    struct dirent *pent = NULL;

    if (pdir == NULL) // if pdir wasn't initialised correctly
    { // print an error message and exit the program
        printf ("\nERROR! level directory could not be initialised correctly %s\n", path);
        return; // exit the function
    }

    while ((pent = readdir (pdir))) // while there is still something in the directory to list
    {
        if (pent == NULL) // if pent has not been initialised correctly
        { // print an error message, and exit the program
            printf ("\nERROR! pent could not be initialised correctly %s\n", path);
            return; // exit the function
        }
        str = path;
        str = str + pent->d_name;

        if(string(pent->d_name).length() > 3)
		{
        	temp.push_back(string(str));
        	count++;
        }
    }
    closedir (pdir);

    sort(temp.begin(), temp.end());

    for(int i = 0; i < (int)temp.size(); i++)
    	levels.push_back(temp.at(i));

    levelPositions.push_back(levels.size());
    levelSetNames.push_back(string(name));
}


void LevelLoader::LoadTwoPlayerLevels(const char *path)
{
	string str = string(path);
	//first off, we need to create a pointer to a directory

    DIR *pdir = NULL; // remember, it's good practice to initialise a pointer to NULL!

    pdir = opendir (path); // "." will refer to the current directory

    struct dirent *pent = NULL;

    if (pdir == NULL) // if pdir wasn't initialised correctly
    { // print an error message and exit the program
        printf ("\nERROR! pdir could not be initialised correctly");
        return; // exit the function
    }
    int n=0;
    while ((pent = readdir (pdir))) // while there is still something in the directory to list
    {
        if (pent == NULL) // if pent has not been initialised correctly
        { // print an error message, currentLevel--;and exit the program
            printf ("\nERROR! pent could not be initialised correctly");
            return; // exit the function
        }
        str = path;
        str = str + pent->d_name;

        if(n++ >= 0)
        {
        	if(string(pent->d_name).length() > 3)
        	{
        	twoPlayerLevels.push_back(string(str));
        	count++;
        	}
        }
    }
    // sort (levels.begin(), levels.end());
    // finally, let's close the directory
    closedir (pdir);
}

int LevelLoader::LevelCount()
{
	return 30;
}

void LevelLoader::SetTwoPlayerLevel(int n){
	currentTwoPlayerLevel = n;
}

void LevelLoader::SetLevel(int n){
	currentSinglePlayerLevel = n;
}

int LevelLoader::SetLevelSet(int newLevel)
{
	if(newLevel >= 0)
	{
		levelSet = (LevelSet)newLevel;
	}
	return 0;
}

void LevelLoader::GotoNextIncomplete(Configuration* config){
	//now move on, until we have reached a non-complete level
	bool completed = false;
	currentSinglePlayerLevel = 0;
	int maxLevel = levelPositions.at((int)levelSet);

	while(!completed /*&& currentLevel < levelPositions.at((int)levelSet) */){
		if(config->GetLevelComplete(CurrentLevelCode())){
			currentSinglePlayerLevel++;
		}
		else{
			completed = true;
		}
	}
}

void LevelLoader::IncLevel(int n){
	if(n > 0 && currentSinglePlayerLevel < 256 - n){
		currentSinglePlayerLevel += n;
	}
	else if(n<0 && currentSinglePlayerLevel>n){
		currentSinglePlayerLevel += n;
	}

	if(currentSinglePlayerLevel < 0)
	{
		currentSinglePlayerLevel = 0;
	}
}

void LevelLoader::NextLevel()
{
	currentSinglePlayerLevel++;
	if(currentSinglePlayerLevel >= (int)levels.size()){
		currentSinglePlayerLevel = 0;
	}
}

void LevelLoader::PreviousLevel()
{
	if(currentSinglePlayerLevel>0)
		currentSinglePlayerLevel--;
}

void LevelLoader::NextTwoPlayerLevel()
{
	currentTwoPlayerLevel++;
	if(currentTwoPlayerLevel >= (int)twoPlayerLevels.size()){
		currentTwoPlayerLevel = 0;
	}
}

void LevelLoader::PreviousTwoPlayerLevel()
{
	currentTwoPlayerLevel--;
	if(currentTwoPlayerLevel < 0){
		currentTwoPlayerLevel = twoPlayerLevels.size()-1;
	}
}



