/*
 * TitleScreen.cpp
 *
 *  Created on: 10 Dec 2009
 *      Author: mat
 */

#include "TitleScreenMenu.h"
#include "OnePlayerLevelSelect.h"
#include "TwoPlayerSetupScreen.h"

using namespace std;

TitleScreenMenu::TitleScreenMenu(MenuItem* newParent, int new_width, int new_height, bool Sound_enabled, int buffer) : MenuItem(newParent, new_width, new_height) {


	sound_enabled = Sound_enabled;
	if (game == NULL) {
		game = new Game(new_width / 2, new_height / 2, 25, 2, sound_enabled, buffer);
		printf("created a new game\n");
	}

	ohnomore = utility->load_image("data/graphics/ohnomore.png");
	titlescreen = utility->load_image("data/graphics/title_screen.png", 255);

	oneplayericon = utility->load_image("data/graphics/1Player.png");
	twoplayericon = utility->load_image("data/graphics/2Player.png");
	musicicon = utility->load_image("data/graphics/music.png");
	musicicon_main = utility->load_image("data/graphics/musicIcon.png");
	levelseticon = utility->load_image("data/graphics/levelset.png");
	logoicon = utility->load_image_zoomed("data/graphics/logo.png", 2);
	//newLevel = utility->load_image_zoomed("data/graphics/newlevel.png", 2);
	newLevel = utility->load_image("data/graphics/newlevel.png");

	//load all the level icons in
	filllevelIcon(utility->load_image("data/graphics/fun.png"), LevelLoader::Fun);
	filllevelIcon(utility->load_image("data/graphics/tricky.png"), LevelLoader::Tricky);
	filllevelIcon(utility->load_image("data/graphics/taxing.png"), LevelLoader::Taxing);
	filllevelIcon(utility->load_image("data/graphics/mayhem.png"), LevelLoader::Mayhem);

	//oh no, more lemmings!
	filllevelIcon(utility->load_image("data/graphics/tame.png"), LevelLoader::Tame);
	filllevelIcon(utility->load_image("data/graphics/crazy.png"), LevelLoader::Crazy);
	filllevelIcon(utility->load_image("data/graphics/wild.png"), LevelLoader::Wild);
	filllevelIcon(utility->load_image("data/graphics/wicked.png"), LevelLoader::Wicked);
	filllevelIcon(utility->load_image("data/graphics/havoc.png"), LevelLoader::Havoc);

	filllevelIcon(utility->load_image("data/graphics/xmas1991.png"), LevelLoader::Xmas1991);
	filllevelIcon(utility->load_image("data/graphics/xmas1992.png"), LevelLoader::Xmas1992);
	filllevelIcon(utility->load_image("data/graphics/frost.png"), LevelLoader::XmasFrost);
	filllevelIcon(utility->load_image("data/graphics/hail.png"), LevelLoader::XmasHail);
	filllevelIcon(utility->load_image("data/graphics/flurry.png"), LevelLoader::XmasFlurry);
	filllevelIcon(utility->load_image("data/graphics/blizzard.png"), LevelLoader::XmasBlizzard);

	soundIcons.push_back(utility->load_image("data/graphics/music.png"));
	soundIcons.push_back(utility->load_image("data/graphics/FX.png"));

	scrollyArea = new SDL_Rect();
	scrollyArea->x = 0;
	scrollyArea->y = new_height - 32;
	scrollyArea->w = new_width;
	scrollyArea->h = 32;
	//scrollyMsg = "                                     Lemmings SDL......all graphics ripped shamelessly from the original Amiga version. So, sorry for that Psygnosis...or Sony now I should say. Well, I don't think I'm doing anything morally wrong, so just enjoy the Lemmings.....                                                ";
	//scrollyMsg = "                                          This is the second release of Lemmings SDL, soon to become Zomblins(?). I've pandored (can you see what I did there?) to the desires of several forum members for this version. Still a few issues to be ironed out but I'm getting there (those damn exit animations are doing my nut in!) For your information the Multiplayer game apparently does work on the Internet as tested by forum member RubiX. He used a program called 'Hamachi' in order to bypass his (I think) firewall settings (The port that needs to be opened is 2001). I have fixed the crappy IP address entry system and made it slightly less crappy but still definately crappy. So as you can see not everything is perfect yet..........Hey, I like writing scrolling messages. Very boring to read though I would imagine!!!!!,.,., :-)........just play the game.......mutliplayer should be lots of fun. I haven't actually played it yet :-( yippeeeee! Let's go!                                             ";scrollPos = pos = 0;
	//scrollyMsg = "                                          LemmingsSDL V0.9.1. Press 'F' or 'F11' for fullscreen mode. If you have problems running fullscreen, then use command line parameters to set screen size (eg LemmingsSDL w 640 h 320 fs 0). Now onto the old scroller.........This is the closest to perfection I've managed to reach so far with this pointless quest and I thought it was time to release it, so all of the 2 or 3 people who actually might get around to having a look at it can! I really don't mind. It's been fun fiddling with the code until it (nearly) works! Programming this game is starting to drive me insane, why am I even typing this crap? The problem is that trying to replicate the Amiga version perfectly is proving to be incredibly difficult, I might just leave this at this and forget about it. The code is out there so anyone is free to try and reach perfection with it (though, quite why anyone would want to do such a strange thing, I'll never know...). Yunno, someone should write a piece of software that emulates these old computers so we can play them perfectly! Anyway, signing off now as this text is plain bat-shit insane!!! byeeee!                                            ";scrollPos = pos = 0;
	//scrollyMsg = "                                          LemmingsSDL V0.9.4 Press 'F' or 'F11' for fullscreen mode. I still don't have a Pandora :-(, so if this runs on an actual machine then I must've set the cross-compiler stuff up properly! Even better if this doesn't cause the game to crash when finishing a level then I've found out what was causing it. If it doesn't start up on a Pandora then you won't even get to read this will you...well, lemmee know anyway then I can start trying to optimise this all a bit bye!!!                                             ";scrollPos = pos = 0;
#if PLATFORM_PANDORA
	scrollyMsg = "                                          Press 'F' or 'F11' for fullscreen.......................LemmingsSDL V0.9.11 !Pandora build! Just another handful of minor changes and polishing. Some changes specific to Pandora, like ensuring hidden cursor doesn't still affect the selected Lemming. Also removed those focus boxes as they looked a bit rubbish didn't they?. Anyway, I think it deserved a Version One as it's pretty perfect but I just couldn't bring myself to do it......next version maybe. Next!? I don't want to do a next version, this is it now!!! Well, unless anyone over at GP32X spots anything that I've missed...which they will! Old scrolly appearing right after this last word...Getting close to finished 100% now! Hah! As if that could ever happen. No, in all honesty, I think development on LSDL is drawing to a close. Any enjoy game progress saving ability in this version!....old scroll appearing in 5...4...3...2...1..Only one update in this version and that is the ability to scroll using DPad...Another minor update! This time I've implemented 'changes to the mini-map', so when a Lemming builds, the little map is updated! Cool huh? Where did I get that idea from I wonder? Also made the most pointless change ever in the history of changes and that's to compress the 2 bytes that were previously being sent during network play down into 1 byte. It will make no difference to any speed related issues of the 2 player game as that is due to the ping rate of the connection, but seeing as this is a for fun project as opposed to my job, I think I'm allowed to add some pointless but (IMO) cool code! I must mention the changes that Covox has made, apart from ensuring that it compiles for the N900 and setting up the bitbucket repo, he's provided several fixes and recently frixed the high CPU usage on the menu screens! Thanks dude! Also, enjoy the onml music and some xmas tunes in the appropriate level sets...here's the previous scoller......................................Some small additions/fixes: Now when you nuke all, it takes longer to go to end game screen, so you can enjoy watching the Lemmings explode! I also noticed a bug where you can nuke all before Lemmings have left the entrance...that's fixed now. There might've been some other things but this aint my day job, so I haven't written a report! I might try and update this scroller with changes...but then again!!!!!!!!!....................Finally got networking, erm...working. Fixed loads of other bugs as well, so the program actually quits without causing a segmentation fault! Always handy! I think this will be the final release as I want to move onto something else, something a bit more original. Only a bit though, staying retro! I've always wanted to make a traditional platformer, a single screen affair ala the great manic miner....hmmmm Bye!!!!!!!                                          Oh, I've returned to add some more to my scrolly. Must be running out things to fix in this game! Well, here's a list of features that I have implemented: First it's a complete re-implementation of Lemmings for the Commodore Amiga. All the origrinal graphics and sound from the Amiga version (though obviously I copied each pixel perfectly by examining my original copy of Lemmings that I have on 3.5 inch floppy disk!). I've painstakingly copied the behaviour of the Lemmings by playing the original and comparing various different levels to see how the Lemmings react to the environmen. It's driven me nearly insane! I know it's not perfect so I take back that this will be the final version as I would like to get each niggle ironed out. See if you can spot the differences? Obviously I can see a few, perhaps most people wouldn't notice...Perhaps the most interesting feature is network play. The 2-player game on the Amiga was really good fun and AFAIK no other version had this two-player option, so to make make it networked was the natural choice of feature to add. The speed of the game depends on the ping value of the network connection, so it could result in a slowed down game. Perhaps I need to detect for this and refuse to run but still...That's it really. It's been a blast but I'm finished now...";scrollPos = pos = 0;
#else
	scrollyMsg = "                                          Press 'F' or 'F11' for fullscreen.......................LemmingsSDL V0.9.11 Just another handful of minor changes and polishing. Some changes specific to Pandora, like ensuring hidden cursor doesn't still affect the selected Lemming. Also removed those focus boxes as they looked a bit rubbish didn't they?. Anyway, I think it deserved a Version One as it's pretty perfect but I just couldn't bring myself to do it......next version maybe. Next!? I don't want to do a next version, this is it now!!! Well, unless anyone over at GP32X spots anything that I've missed...which they will! Old scrolly appearing right after this last word...Getting close to finished 100% now! Hah! As if that could ever happen. No, in all honesty, I think development on LSDL is drawing to a close. Any enjoy game progress saving ability in this version!....old scroll appearing in 5...4...3...2...1..Smallish update, added ability to select action with arrow keys! cool huh? Another minor update! This time I've implemented 'changes to the mini-map', so when a Lemming builds, the little map is updated! Cool huh? Where did I get that idea from I wonder? Also made the most pointless change ever in the history of changes and that's to compress the 2 bytes that were previously being sent during network play down into 1 byte. It will make no difference to any speed related issues of the 2 player game as that is due to the ping rate of the connection, but seeing as this is a for fun project as opposed to my job, I think I'm allowed to add some pointless but (IMO) cool code! I must mention the changes that Covox has made, apart from ensuring that it compiles for the N900 and setting up the bitbucket repo, he's provided several fixes and recently frixed the high CPU usage on the menu screens! Thanks dude! Also, enjoy the onml music and some xmas tunes in the appropriate level sets...here's the previous scoller......................................Some small additions/fixes: Now when you nuke all, it takes longer to go to end game screen, so you can enjoy watching the Lemmings explode! I also noticed a bug where you can nuke all before Lemmings have left the entrance...that's fixed now. There might've been some other things but this aint my day job, so I haven't written a report! I might try and update this scroller with changes...but then again!!!!!!!!!....................Finally got networking, erm...working. Fixed loads of other bugs as well, so the program actually quits without causing a segmentation fault! Always handy! I think this will be the final release as I want to move onto something else, something a bit more original. Only a bit though, staying retro! I've always wanted to make a traditional platformer, a single screen affair ala the great manic miner....hmmmm Bye!!!!!!!                                          Oh, I've returned to add some more to my scrolly. Must be running out things to fix in this game! Well, here's a list of features that I have implemented: First it's a complete re-implementation of Lemmings for the Commodore Amiga. All the origrinal graphics and sound from the Amiga version (though obviously I copied each pixel perfectly by examining my original copy of Lemmings that I have on 3.5 inch floppy disk!). I've painstakingly copied the behaviour of the Lemmings by playing the original and comparing various different levels to see how the Lemmings react to the environmen. It's driven me nearly insane! I know it's not perfect so I take back that this will be the final version as I would like to get each niggle ironed out. See if you can spot the differences? Obviously I can see a few, perhaps most people wouldn't notice...Perhaps the most interesting feature is network play. The 2-player game on the Amiga was really good fun and AFAIK no other version had this two-player option, so to make make it networked was the natural choice of feature to add. The speed of the game depends on the ping value of the network connection, so it could result in a slowed down game. Perhaps I need to detect for this and refuse to run but still...That's it really. It's been a blast but I'm finished now...";scrollPos = pos = 0;
#endif
	currentLevelSet=0;
	levelLoader->GotoNextIncomplete(config);
	//now add it's child screen
	onePlayerLevelSelectObject = new OnePlayerLevelSelect(this);
	twoPlayerSetupScreenObject = new TwoPlayerSetupScreen(this);
	designer = NULL;//new DesignerScreen(this);

	if(sound_enabled){
		playingMusic = true;
	}
	else{
		playingMusic = false;
	}

	if(plevelSelect == NULL) plevelSelect = onePlayerLevelSelectObject;
	Mix_HookMusicFinished( &MenuItem::FreeMusic );
	playmusic();

	if(screen_width == 800){
		yoffset = 25;
	}else{
		yoffset = 0;
	}
	iconTop = 220 + yoffset;
	iconWidth = 130;
	xoffset = (new_width - 5*iconWidth )/2 + 8;

	AddClickArea(xoffset + iconWidth*0, iconTop, oneplayericon->clip_rect.w, oneplayericon->clip_rect.h,"", onePlayerLevelSelectObject, oneplayericon);
	AddClickArea(xoffset + iconWidth*1, iconTop, twoplayericon->clip_rect.w, twoplayericon->clip_rect.h,"", twoPlayerSetupScreenObject, twoplayericon);
	AddClickArea(xoffset + iconWidth*2, iconTop, newLevel->clip_rect.w, newLevel->clip_rect.h,"", NULL, newLevel);
	AddClickArea(xoffset + iconWidth*3, iconTop, musicicon_main->clip_rect.w, musicicon_main->clip_rect.h,"", NULL, musicicon_main);
	AddClickArea(xoffset + iconWidth*4, iconTop, levelseticon->clip_rect.w, levelseticon->clip_rect.h,"", NULL, levelseticon);

	greenTiledBackground = false;
}


TitleScreenMenu::TitleScreenMenu(MenuItem* newParent) : MenuItem(newParent) {
}

TitleScreenMenu::~TitleScreenMenu() {
	printf("Desctructor for TitleScreenMenu\n");

	delete(onePlayerLevelSelectObject);
	delete(twoPlayerSetupScreenObject);
	delete(scrollyArea);

	SDL_FreeSurface(oneplayericon);
	SDL_FreeSurface(twoplayericon);
	SDL_FreeSurface(musicicon);
	SDL_FreeSurface(levelseticon);
	SDL_FreeSurface(logoicon);

	//delete background
	SDL_FreeSurface(titlescreen);
	SDL_FreeSurface(ohnomore);
	for(unsigned int n = 0; n < levelIcons.size(); n++)
		SDL_FreeSurface(levelIcons[n]->icon);

	for(unsigned int n = 0; n < soundIcons.size(); n++)
		SDL_FreeSurface(soundIcons[n]);

	delete(game);
}

void TitleScreenMenu::DrawSelf(SDL_Surface* screen){
	std::stringstream stream;
	stream.clear();

	//clear screen
	if(forceRedraw){
		TileBackground(screen);
		utility->apply_surface((screen->clip_rect.w-logoicon->clip_rect.w)/2,22 + yoffset,logoicon,screen,NULL);
		if(currentLevelSet > 3) utility->apply_surface((screen->clip_rect.w-logoicon->clip_rect.w)/2 + 95, 33 + yoffset, ohnomore, screen, NULL);

		utility->apply_surface(xoffset + iconWidth*4 + 4, iconTop + 39, levelIcons[currentLevelSet]->icon, screen, NULL);
		utility->apply_surface(xoffset + iconWidth*3 + 4, iconTop + 39, soundIcons[currentSoundSetting], screen, NULL);
		forceRedraw = false;
	}

	int xPos = 0;
	int h = 32;
	int yPos = screen->clip_rect.h - h;
	int scrollLength = 55;

	stream.str("");
	stream << scrollyMsg.substr(pos, scrollLength );

	SDL_FillRect(screen, scrollyArea, SDL_MapRGB( screen->format, 0x00, 0x00, 0x00 ) );

	fontRenderer->RenderString(screen, stream.str(), (xPos - scrollPos/100), yPos, GREEN, ABSOLUTE);

	scrollPos += 250;
	if(scrollPos >= 16*4*100)
	{
		scrollPos = 0;
		pos += 4;
		if(pos > scrollyMsg.length() - scrollLength )
		  pos = 0;
	}
}

void TitleScreenMenu::HandleKey(int k){
	if(k == SDLK_1){
		SetCurrentScreen(onePlayerLevelSelectObject);
		Mix_FadeOutMusic(1000);
		playingMusic = false;
	}
	else if(k == SDLK_2)
		SetCurrentScreen(twoPlayerSetupScreenObject);
	else if(k == SDLK_UP){
		if((++currentLevelSet) >= (int)levelIcons.size())
			currentLevelSet=(int)levelIcons.size()-1;
		levelLoader->SetLevelSet(currentLevelSet);
		//levelLoader->SetLevel(0);
		levelLoader->GotoNextIncomplete(config);
		forceRedraw=true;
	}else if(k == SDLK_DOWN){
		if((--currentLevelSet) < 0)
			currentLevelSet = 0;
		levelLoader->SetLevelSet(currentLevelSet);
		//levelLoader->SetLevel(0);
		levelLoader->GotoNextIncomplete(config);
		forceRedraw=true;
	}else if(k == SDLK_RETURN){
		levelLoader->SetLevelSet(currentLevelSet);
		SetCurrentScreen(onePlayerLevelSelectObject);
		if(sound_enabled){
			Mix_FadeOutMusic(1000);
		}
		playingMusic = false;
		forceRedraw=true;
	}else if(k == SDLK_m){
		if(++currentSoundSetting  >= soundIcons.size()){
			playingMusic=true;
			game->SetMusicOn();
			playmusic();
			forceRedraw=true;
		}
		else if(currentSoundSetting==1)
		{
			playingMusic=false;
			game->SetMusicOff();
			Mix_FadeOutMusic(1000);
			forceRedraw=true;
		}
	}
}

void TitleScreenMenu::HandleMouse(int mx,int my,long lb,long rb){
	if(leftclick) {
		//is it in the vicinity of 1-player?
		if(mx > 278 && mx < 325 && my > 244 && my < 370) {
			SetCurrentScreen(designer);
			forceRedraw=true;
		}
		if(mx >= xoffset + iconWidth*4 && mx < xoffset + iconWidth*4 + levelseticon->clip_rect.w
				&& my > iconTop && my < iconTop + levelseticon->clip_rect.h/2) {
			if((++currentLevelSet) >= (int)levelIcons.size()){
				currentLevelSet=(int)levelIcons.size()-1;
			}
			levelLoader->SetLevelSet(currentLevelSet);
			levelLoader->GotoNextIncomplete(config);
			forceRedraw=true;
		}
		if(mx >= xoffset + iconWidth*4 && mx < xoffset + iconWidth*4 + levelseticon->clip_rect.w
				&& my > iconTop + levelseticon->clip_rect.h/2 && my < iconTop + levelseticon->clip_rect.h) {
			if((--currentLevelSet) < 0){
				currentLevelSet = 0;
			}
			levelLoader->SetLevelSet(currentLevelSet);
			levelLoader->GotoNextIncomplete(config);
			levelLoader->SetLevel(0);
			forceRedraw=true;
		}
		if(mx >= xoffset + iconWidth*3 && mx < xoffset + iconWidth*3 + musicicon_main->clip_rect.w
				&& my > iconTop && my < iconTop + musicicon_main->clip_rect.h) {
			if(++currentSoundSetting  >= soundIcons.size()){
				playingMusic=true;
				game->SetMusicOn();
				playmusic();
				forceRedraw=true;
			}
			else if(currentSoundSetting==1)
			{
				playingMusic=false;
				game->SetMusicOff();
				Mix_FadeOutMusic(1000);
				forceRedraw=true;
			}
		}
	}
}

void TitleScreenMenu::playmusic(){
	if(sound_enabled){
		if(playingMusic){
			currentSoundSetting = 0;
			if(Mix_PlayMusic(Mix, -1) == -1) {
				printf("Mix_PlayMusic: %s\n", Mix_GetError());
			}
		}
	}
	else printf("not playing music\n");
}

void TitleScreenMenu::filllevelIcon(SDL_Surface* image, LevelLoader::LevelSet set )
{
	LevelIcon* temp = new LevelIcon();
	temp->icon = image;
	temp->levelSet = set;
	levelIcons.push_back(temp);
}

void TitleScreenMenu::Init(){
	playmusic();
	scrollPos = 0;
	MenuItem::Init();
}


