/*
 * DataBuffer.h
 *
 *  Created on: 1 Mar 2010
 *      Author: mat
 */

#ifndef LSDLSERVER_H__
#define LSDLSERVER_H_
#include "SDL/SDL_thread.h"
#include <vector>
#include "SDL/SDL_net.h"
#include <string>

#include "../DataBuffer.h"

#define INVALID_INDEX 81
#define INVALID_NEW_STATE 81

class LSDLServer {
public:
	LSDLServer();
	virtual ~LSDLServer();

	/*
	 * Starts off the server, waiting for clients to join
	 */
    bool Start();

	/*
	//the fancy (and non-wokring method)
	void StartThread();
	bool EndThread();
	void LockData();
	void UnlockData();
	bool RequestForData(DataBuffer::NetData* currentChange);
	bool StoreLocalChange(DataBuffer::NetData** change1, DataBuffer::NetData* currentGameChange);
	static int max_frame_store;//max frame to store!
	void push_back(DataBuffer::NetData*);
	DataBuffer::NetData* at(int);
	int size();
	*/

	/*
	// all the DataBuffer stuffl
	void AddData(unsigned char index, unsigned char state, unsigned int findex);
	NetData* GetData();

	bool ConnectToServer(std::string);
	bool ConnectToClient();
	bool CloseConnection();
	void ResetConnection();
	bool IsClientConnected();
	bool IsReanimationRequired(DataBuffer::NetData* IncomingData, DataBuffer::NetData* gameChange);
	bool RequestForData(DataBuffer::NetData *lemInData, DataBuffer::NetData *lemOutData);
	int GetLevelFromServer();
	bool SetClientLevel(int newLevel);
*/

private:
	SDL_Thread *thread;
	static int my_thread( void *data );

	TCPsocket sd, csd; // Socket descriptor, Client socket descriptor
	bool quit;
	int fcount;
	int gameType;
	bool connected;
	bool connectedToClient;
	int data_transfer_size;

//	char Compress(DataBuffer::NetData *data, int offset);
//	void Decompress(DataBuffer::NetData *data, char compressed, int offset);

	//bool thread_running;
	//static NetData* arLemInData;//array of n frame changes
	//static NetData* arTempLemInData;//array of n frame changes
	//static NetData* arLemOutData;//array of n frame changes
	//static SDL_mutex *datalock;

	//static void StoreRecievedData();
	//static void ClearOutData();

	//std::vector<DataBuffer::NetData> arAllGameChanges;
};


#endif /* LSDLSERVER_H_ */
